#include <SPI.h>
#include <Ethernet.h>
#include <ModbusIP.h>
#include <ESP32Encoder.h>

ModbusIP mb;

byte mac[] = {0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED};  
byte ip[] = {192, 168, 1, 222}; 

int regs[] = {1,  2,  3,  9,  10, 11, 4,  5,  6,  7}; 
int pins[] = {13, 14, 27, 32, 35, 34, 25, 15, 21, 22};

int currentPin;

ESP32Encoder encoder;

void setup() {
  //Serial.begin(115200);
  
  mb.config(mac, ip);
  
  for(int i = 0; i < sizeof(regs)/sizeof(regs[0]); i++) {
    pinMode(pins[i], INPUT_PULLUP);
    mb.addCoil(regs[i]); 
  } 

  encoder.attachFullQuad(2, 4);
  encoder.clearCount();
  mb.addHreg(55);
}

void loop() {
  mb.task();
   
  for(int i = 0; i < sizeof(regs)/sizeof(regs[0]); i++)
  {
    if (!digitalRead(pins[i]) && i < 6 && currentPin != pins[i]) {
        currentPin = pins[i];
        encoder.clearCount();
        mb.Hreg(55, 0);
    }
    
    mb.Coil(regs[i], !digitalRead(pins[i]));
  }

  if((int16_t)encoder.getCount() > 32760 ||(int16_t)encoder.getCount() < -32760){
    encoder.clearCount();
    mb.Hreg(55, 0);
  }
  
  if(!digitalRead(25)) {
    encoder.resumeCount();
    mb.Hreg(55, (int16_t)encoder.getCount());
  } else {
    encoder.pauseCount();
  }
}
